--- old/usr/src/Makefile.master	Mon Jun 25 17:12:19 2012
+++ new/usr/src/Makefile.master	Mon Jun 25 17:12:19 2012
@@ -198,6 +198,7 @@
 CTFCVTPTBL=	$(ONBLD_TOOLS)/bin/ctfcvtptbl
 CTFFINDMOD=	$(ONBLD_TOOLS)/bin/ctffindmod
 XREF=		$(ONBLD_TOOLS)/bin/xref
+BUILDSTAMP=	$(ONBLD_TOOLS)/bin/buildstamp
 FIND=		/usr/bin/find
 PERL=		/usr/bin/perl
 PYTHON_24=	/usr/bin/python2.4
@@ -957,6 +958,8 @@
 $(STRIP_COMMENTS)PROCESS_COMMENT=  @?${MCS} -d -a $(RELEASE_CM) -a $(DEV_CM)
 $(RELEASE_BUILD)PROCESS_COMMENT=   @?${MCS} -d -a $(RELEASE_CM)
 
+PROCESS_BUILDSTAMP=	@?${MCS} -n .ILLUMOS_buildstamp -d -a "`${BUILDSTAMP}`"
+
 STRIP_STABS=			   :
 $(RELEASE_BUILD)STRIP_STABS=	   $(STRIP) -x $@
 
--- old/usr/src/pkg/manifests/developer-build-onbld.mf	Mon Jun 25 17:12:20 2012
+++ new/usr/src/pkg/manifests/developer-build-onbld.mf	Mon Jun 25 17:12:20 2012
@@ -89,6 +89,7 @@
 file path=opt/onbld/bin/bldenv mode=0555
 file path=opt/onbld/bin/bringovercheck mode=0555
 file path=opt/onbld/bin/build_cscope mode=0555
+file path=opt/onbld/bin/buildstamp mode=0555
 file path=opt/onbld/bin/cddlchk mode=0555
 file path=opt/onbld/bin/check_rtime mode=0555
 file path=opt/onbld/bin/checkpaths mode=0555
--- old/usr/src/tools/scripts/Makefile	Mon Jun 25 17:12:20 2012
+++ new/usr/src/tools/scripts/Makefile	Mon Jun 25 17:12:20 2012
@@ -46,7 +46,8 @@
 	webrev \
 	which_scm \
 	ws \
-	xref
+	xref \
+	buildstamp
 
 PERLFILES= \
 	check_rtime \
--- /dev/null	Mon Jun 25 17:12:20 2012
+++ new/usr/src/tools/scripts/buildstamp.sh	Mon Jun 25 17:12:20 2012
@@ -0,0 +1,53 @@
+#!/usr/bin/ksh -p
+#
+# CDDL HEADER START
+#
+# The contents of this file are subject to the terms of the
+# Common Development and Distribution License (the "License").
+# You may not use this file except in compliance with the License.
+#
+# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+# or http://www.opensolaris.org/os/licensing.
+# See the License for the specific language governing permissions
+# and limitations under the License.
+#
+# When distributing Covered Code, include this CDDL HEADER in each
+# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+# If applicable, add the following below this CDDL HEADER, with the
+# fields enclosed by brackets "[]" replaced with your own identifying
+# information: Portions Copyright [yyyy] [name of copyright owner]
+#
+# CDDL HEADER END
+#
+
+#
+# Copyright 2012 Joshua M. Clulow <josh@sysmgr.org>
+#
+
+WHICH_SCM=which_scm
+CW=cw
+NAWK=nawk
+
+
+echo "date: $(date)"
+echo "uname: $(uname -a)"
+
+$WHICH_SCM | read scm_type junk || exit 1
+cmd=
+if [[ $scm_type == "git" ]]; then
+	cmd="git rev-parse --verify HEAD"
+elif [[ $scm_type == "mercurial" ]]; then
+	cmd="hg log -r tip --template {node}"
+fi
+if [[ -n $cmd ]]; then
+	echo "scm: ${scm_type} $($cmd)"
+fi
+
+$CW -_versions 2>&1 | $NAWK '
+  /^primary:/ { print; watch = 1; next; }
+  watch == 1  { print("primaryversion: " $0); watch = 0; next; }
+  /^shadow:/  { print; watch = 2; next; }
+  watch == 2  { print("shadowversion: " $0); watch = 0; next; }
+'
+
+exit 0
--- old/usr/src/uts/Makefile.targ	Mon Jun 25 17:12:21 2012
+++ new/usr/src/uts/Makefile.targ	Mon Jun 25 17:12:21 2012
@@ -124,6 +124,7 @@
 	    -DUTS_VERSION=\"`$(VERSION_STRING) | sed -e 's/ /_/g'`\" \
 	    -DUTS_PLATFORM=\"$(UNAME_M)\" -o $@ $(SRC)/uts/common/os/vers.c
 	$(CTFCONVERT_O)
+	$(PROCESS_BUILDSTAMP) $@
 	$(POST_PROCESS_O)
 
 $(LINTS_DIR)/vers.ln: $(SRC)/uts/common/os/vers.c
